function P=legendre_u(nmax,costheta)

%% P=legendre_u(n,x) returns the values of the unassociated legendre
%% polynomial of order n.
%% This is a recursive implementation;
%% Franz Zotter, 2010, Institute of Electronic Music and Acoustics, Austria.
costheta=costheta(:);
P=zeros(length(costheta),nmax+1);
P(:,1)=1; 
if nmax>0
   P(:,2)=costheta;
end

ofs=1;
for m=1:nmax-1
    P(:,(m+1+ofs))=( (2*m+1)*costheta.*P(:,m+ofs) - m*P(:,m-1+ofs) )/(m+1);
end

