if ~exist('SOFAload')
    run('SOFA-API\API_MO\SOFAstart')
end

D=SOFAload('HRIR_CIRC360.sofa');
y=(0:length(D.Data.IR(:,1))-1)/length(D.Data.IR(:,1))*360;
x=(0:length(D.Data.IR(1,1,:))-1)/D.Data.SamplingRate*1000;
[x,y]=meshgrid(x,y);

hrir=permute(D.Data.IR,[3 1 2]);
hrirL=resample(hrir(:,:,1),44100,D.Data.SamplingRate);
write2pdmtx('../Pd/ku100L.mtx',hrirL);
hrirR=resample(hrir(:,:,2),44100,D.Data.SamplingRate);
write2pdmtx('../Pd/ku100R.mtx',hrirR);
%%
figure
pc=pcolor(x,y,squeeze(circshift(D.Data.IR(:,1,:),-89)));
set(pc,'EdgeColor','none')
xlabel('t in ms')
ylabel('azi in deg')
C=[ones(32,1) repmat(linspace(0,1,32)',1,2).^1.3];
C=[C;flipud(circshift(C',2)')];
colormap(flipud(C))
caxis([-1 1])
colorbar

set(gcf,'PaperUnits','centimeters','PaperPosition',[0 0 13 8])
print('-dpng','-r300','KU100_HRIR_horizL.png')

figure
pc=pcolor(x,y,squeeze(circshift(D.Data.IR(:,2,:),-89)));
set(pc,'EdgeColor','none')
xlabel('t in ms')
ylabel('azi in deg')
colormap(flipud(C))
caxis([-1 1])
colorbar

set(gcf,'PaperUnits','centimeters','PaperPosition',[0 0 13 8])
print('-dpng','-r300','KU100_HRIR_horizR.png')
%%
run('miro')
%%
figure
load('HRIR_FULL2DEG.mat')
y=HRIR_FULL2DEG.elevation([(1:89)+8010 (89:-1:1)]);
y(90:end)=2*pi-y(90:end);
L=length(HRIR_FULL2DEG.irChOne(:,1));
x=(0:L-1)/HRIR_FULL2DEG.fs*1000;
[x,y]=meshgrid(x,y);
IRs=double(HRIR_FULL2DEG.irChOne(:,89:-1:1))';
% IRs(45:end,:)=circshift(IRs(45:end,:)',1)';
IRs=[IRs;double(HRIR_FULL2DEG.irChOne(:,(1:89)+8010))'];

y=y*180/pi-90;
pc=pcolor(x,y,IRs);
% pc=pcolor(IRs);
set(pc,'EdgeColor','none')
C=[ones(32,1) repmat(linspace(0,1,32)',1,2).^1.3];
C=[C;flipud(circshift(C',2)')];
colormap(flipud(C))
caxis([-1 1])
colorbar
ylabel('ia. polar in deg')
xlabel('time in ms')
set(gcf,'PaperUnits','centimeters','PaperPosition',[0 0 13 8])
print('-dpng','-r300','KU100_HRIR_vertL.png')

figure
IRs=double(HRIR_FULL2DEG.irChTwo(:,89:-1:1))';
IRs=[IRs;double(HRIR_FULL2DEG.irChTwo(:,(1:89)+8010))'];
pc=pcolor(x,y,IRs);
% pc=pcolor(IRs);
set(pc,'EdgeColor','none')
colormap(flipud(C))
caxis([-1 1])
colorbar
ylabel('ia. polar in deg')
xlabel('time in ms')
set(gcf,'PaperUnits','centimeters','PaperPosition',[0 0 13 8])
print('-dpng','-r300','KU100_HRIR_vertR.png')

%%
figure
IRs=double(HRIR_FULL2DEG.irChTwo(:,89:-1:1))';
IRs=[IRs;double(HRIR_FULL2DEG.irChTwo(:,(1:89)+8010))'];
H=fft(IRs').';
L=size(H,2);
H=H(:,1:L/2+1);
y=HRIR_FULL2DEG.elevation([(1:89)+8010 (89:-1:1)]);
y(90:end)=2*pi-y(90:end);
x=(0:L/2)/L*HRIR_FULL2DEG.fs;
[x,y]=meshgrid(x,y);
mindB=-25;
y=y*180/pi-90;
H=db(H);
H=H-max(H(:));
H=max(H,mindB);
pc=pcolor(x,y,H);
% pc=pcolor(H);
set(pc,'EdgeColor','none')
colorbar
set(gca,'XScale','log','XTick',...
    [25 32 40 50 63 80 100 125 160 200 ...
    250 316 400 500 625 800 1000 1250 1600 2000 ...
    2500 3150 4000 5000 6300 8000 10000 12500 16000 20000],...
    'XTickLabel',...
    {'0','32','','','63','','','125','','','250','','','500','',...
    '','1k','','','2k','','','4k','','','8k','','','16k',''},...
    'XMinorTick','off')

colormap(flipud(hot))
ylabel('ia. polar in deg')
xlabel('freq in Hz')
set(gcf,'PaperUnits','centimeters','PaperPosition',[0 0 13 8])
print('-dpng','-r300','KU100_HRTF_vertR.png')
%%
D=SOFAload('hrtfb_nh710.sofa');
%%
idx1=find(D.SourcePosition(:,1)==0);
[~,idx1s]=sort(D.SourcePosition(idx1,2));
idx1=idx1(idx1s);
idx2=find(D.SourcePosition(:,1)==180);
[~,idx2s]=sort(D.SourcePosition(idx2,2),'descend');
idx2=idx2(idx2s);
lata=D.SourcePosition([idx1;idx2],1);
pola=D.SourcePosition([idx1;idx2],2);
pola(end/2:end)=180-pola(end/2:end);
IRs=D.Data.IR([idx1;idx2],:,:);
IRs=squeeze(IRs(:,1,:));
IRs=IRs/max(IRs(:));
L=size(IRs,2);
t=(0:L-1)/D.Data.SamplingRate*1000;
[x,y]=meshgrid(t,pola);

pc=pcolor(x,y,IRs);
% pc=pcolor(IRs);
set(pc,'EdgeColor','none')
colormap(flipud(C))
caxis([-1 1])
colorbar
ylabel('ia. polar in deg')
xlabel('time in ms')
set(gcf,'PaperUnits','centimeters','PaperPosition',[0 0 13 8])
%%
H=db(fft(IRs').');
H=H(:,1:end/2+1);
H=H-max(H(:));
H=max(H,mindB);
f=linspace(0,D.Data.SamplingRate/2,size(H,2));
[x,y]=meshgrid(f,pola);
pc=pcolor(x,y,H);
% pc=pcolor(H);
set(pc,'EdgeColor','none')
colorbar
set(gca,'XScale','log','XTick',...
    [25 32 40 50 63 80 100 125 160 200 ...
    250 316 400 500 625 800 1000 1250 1600 2000 ...
    2500 3150 4000 5000 6300 8000 10000 12500 16000 20000],...
    'XTickLabel',...
    {'0','32','','','63','','','125','','','250','','','500','',...
    '','1k','','','2k','','','4k','','','8k','','','16k',''},...
    'XMinorTick','off')
ylim([-90 270])
colormap(flipud(hot))
ylabel('ia. polar in deg')
xlabel('freq in Hz')
set(gcf,'PaperUnits','centimeters','PaperPosition',[0 0 13 8])
print('-dpng','-r300','ZotterL.png')

idx=find(D.SourcePosition(:,2)==0);
hrir=permute(D.Data.IR(idx,:,:),[3 1 2]);
hrir=hrir/max(abs(hrir(:)));
hrirL=resample(hrir(:,:,1),44100,D.Data.SamplingRate);
write2pdmtx('../Pd/myhrirL.mtx',hrirL);
hrirR=resample(hrir(:,:,2),44100,D.Data.SamplingRate);
write2pdmtx('../Pd/myhrirR.mtx',hrirR);

