function bn=sph_bessel_nearfield(x,N)
% function bn=sph_bessel(x,N)
%
% evaluates the nearfield approximation for the
% spherical Bessel functions (part of the regular solution)
% up to the degree N
% the definition was taken from:
%
% E. G. Williams, "Fourier Acoustics", 
% Academic Press, San Diego, 1999.
%
% Franz Zotter (zotter@iem.at), 
% Institute of Electronic Music and Acoustics,
% 2007.
%
% this is a recursive implementation of the
% power x^n and the double factorial


x=x(:);

ofs=1;
bn=zeros(length(x),N+1);

bn(:,0+ofs)=ones(size(x));
for n=1:N
   bn(:,n+ofs)=x.*bn(:,n-1+ofs)/(2*n+1);
end
