function hn=sph_hankel1(x,N)
% function hn=sph_hankel1(x,N)
%
% evaluates all spherical Hankel functions of
% the first kind (part of the singular solution)
% up to the degree N
% the definition was taken from:
%
% E. G. Williams, "Fourier Acoustics", 
% Academic Press, San Diego, 1999.
%
% this function depends on 
% sph_bessel_nearfield.m
% sph_bessel.m
% sph_neumann.m
%
% Franz Zotter (zotter@iem.at), 
% Institute of Electronic Music and Acoustics,
% 2007.
%
% i have found the numerical borders of 
% the recursive empirically on a 32 bit
% machine 

hn=sph_bessel(x,N)+i*sph_neumann(x,N);


