function hnd=sph_hankel1_diff(x,N)
% function hnd=sph_hankel1_diff(x,N)
%
% evaluates all derivatives of the 
% spherical Hankel functions of
% the first kind (part of the singular solution)
% up to the degree N
% the definition was taken from:
%
% E. G. Williams, "Fourier Acoustics", 
% Academic Press, San Diego, 1999.
%
% this function depends on 
% sph_bessel_nearfield.m
% sph_bessel.m
% sph_bessel_diff.m
% sph_neumann.m
% sph_neumann_diff.m
%
% Franz Zotter (zotter@iem.at), 
% Institute of Electronic Music and Acoustics,
% 2007.
%

x=x(:);

hnd=sph_bessel_diff(x,N)+i*sph_neumann_diff(x,N);



