function hn=sph_hankel2(x,N)
% function hn=sph_hankel2(x,N)
%
% evaluates all spherical Hankel functions of
% the second kind (part of the singular solution)
% up to the degree N
% the definition was taken from:
%
% E. G. Williams, "Fourier Acoustics", 
% Academic Press, San Diego, 1999.
%
% this function depends on 
% sph_bessel_nearfield.m
% sph_bessel.m
% sph_neumann.m
% sph_hankel1.m
%
% Franz Zotter (zotter@iem.at), 
% Institute of Electronic Music and Acoustics,
% 2007.
%

x=x(:);

hn=conj(sph_hankel1(x,N));

