figure(1)
clf
a=.0875;
N1=40;
f1=2500;
N=160;
Nfft=4096;
fs=44100;
f=linspace(0,fs/2,Nfft/2+1);
f(1)=f(2)/4;
f=f(:);
c=343;


costheta=cos((0:1:180)*pi/180);
n=0:N;
itnpoP=repmat(1i.^(n-1).*(2*n+1),length(costheta),1).*...
    legendre_u(N,costheta);

ka=2*pi*f/c*a;
Hh1=repmat(1./ka(f<=f1).^2,1,N1+1)./sph_hankel2_diff(ka(f<=f1),N1);
Hh=repmat(1./ka(f>f1).^2,1,N+1)./sph_hankel2_diff(ka(f>f1),N);


H=[Hh1*itnpoP(:,1:N1+1).'; Hh*itnpoP.'];

% ; ...
%

fterz=[1000 1265 1600]'*2.^(-6:4);
fterz=fterz(:);
fstr=cell(1,length(fterz));
for k=1:length(fterz)
    if mod(k,3)==1
        if fterz(k)>999
            fstr{k}=sprintf('%2.0fk',fterz(k)/1000);
        elseif fterz(k)<70
            fstr{k}=sprintf('%3.1f',fterz(k));
        else
            fstr{k}=sprintf('%2.0f',fterz(k));
        end
    end
end

subplot(311)
HdB=db(H);
plot(f,HdB)
set(gca,'XScale','log','Xtick',fterz,'XTickLabel',fstr);
grid on
xlim([20 20000])
ylabel('|H| in dB')
subplot(312)
plot(f,angle(H)*180/pi)
set(gca,'XScale','log','Xtick',fterz,'XTickLabel',fstr);
grid on
xlim([20 20000])
ylabel('\angle H in ')
subplot(313)
A=angle(H);
for k=8:size(A,1)
    A(k,:)=A(k,:)-round((A(k,:)-A(k-1,:))/(2*pi))*2*pi;
end
% Ggr=(mod(circshift(A,1)-A+pi,2*pi)-pi)*Nfft/(2*pi)/fs*1e6;
Tgr=(circshift(A,1)-A)*Nfft/(2*pi)/fs;
Tph=-A.*repmat(1./(2*pi*f(:)),1,size(A,2));
plot(f,Tph*1e6);
hold on
plot(f,Tgr*1e6,'k--');
set(gca,'XScale','log','Xtick',fterz,'XTickLabel',fstr);
grid on
xlim([20 20000])
ylim([-.7 .7]*1000)
ylabel('\tau_{ph}, \tau_{gr} in \mus')

% save sphdiffr.mat HdB Tgr Tph f

%% plot diffraction parameters a,taugr,tauph
figure
clf
idx=[13 24 48 94 188 376 752];
phi=0:360;
Taumodel=zeros(size(phi));
Taumodel(phi<=90)=-a/c*cos(phi(phi<=90)*pi/180);
Taumodel(phi>90)=a/c*(phi(phi>90)*pi/180-pi/2);
Taumodel(181:361)=fliplr(Taumodel(1:181));
fc=1500;
aa=.15;
Hmodel=db(1+aa+...
     (1-aa)*((1i*f(idx)/fc)./(1+1i*f(idx)/fc)*sin(0.9*pi/2*cos(phi/180*pi))) ...
   );
idxphi=[1:181 180:-1:1];
subplot(211)
hdbnrml=6*(f/700).^2./(1+(f/700).^2);
hdbnrml(:)=1;
plot(phi,db(H(idx,idxphi))'.*repmat(1./hdbnrml(idx)',length(idxphi),1),'LineWidth',1)
% hold on
% plot(phi,Hmodel,'k-','LineWidth',0.5);
ylabel('H in dB')
xlabel('aural polar angle in ')
axis tight
ylim([-17 7])
legend('125Hz','250Hz','500Hz','1kHz','2kHz','4kHz','8kHz','location','eo')
grid on
subplot(212)
% plot(phi,Taumodel*136,'k--','LineWidth',2);
% hold on
plot(phi,Tph(idx,idxphi)'*1e6,'LineWidth',1);
hold on
plot(phi,(Tgr(idx,idxphi)'-Tph(idx,idxphi)')*1e6,'--','LineWidth',1);
ylabel('\tau_{ph}, (\tau_{gr}-\tau_{ph}) in \mu s')
xlabel('aural polar angle in ')
axis tight
legend('125Hz','250Hz','500Hz','1kHz','2kHz','4kHz','8kHz','location','eo')
grid on
set(gcf,'PaperUnits','centimeters','PaperPosition',...
    [0 0 13 9]);
ylim([-400 400])
print('-depsc','spherediffraction.eps')

figure
subplot(211)
plot(phi,Hmodel,'LineWidth',1)
ylabel('H in dB')
xlabel('aural polar angle in ')
axis tight
ylim([-17 7])
legend('125Hz','250Hz','500Hz','1kHz','2kHz','4kHz','8kHz','location','eo')
grid on

subplot(212)
plot(phi,Taumodel*1e6,'LineWidth',1)
ylabel('\tau_{ph}, (\tau_{gr}-\tau_{ph}) in \mu s')
xlabel('aural polar angle in ')
axis tight
legend('model','location','eo')
grid on
set(gcf,'PaperUnits','centimeters','PaperPosition',...
    [0 0 13 9]);
ylim([-400 400])
print('-depsc','model.eps')

%%
break
figure(2)
[b,a]=butter(3,2*[16000]/fs);
Hf=[H;conj(H(end-1:-1:2,:))];
Hf=repmat(fft(b(:),Nfft)./fft(a(:),Nfft),1,size(Hf,2)).*Hf;
hrir_sph=real(ifft(Hf));
t=[0:Nfft/2 -Nfft/2+1:-1]'/fs*1e6;
plot(circshift(t,100),circshift(hrir_sph,100))
xlim([-1000 1000])
xlabel('t in \mus')
ylabel('h(t)')
grid on
break
% save hrir_sph.mat hrir_sph

%%

load hrir_sph;
fs=44100;
fterz=[1000 1265 1600]'*2.^(-6:4);
fterz=fterz(:);
fstr=cell(1,length(fterz));
for k=1:length(fterz)
    if mod(k,3)==1
        if fterz(k)>999
            fstr{k}=sprintf('%2.0fk',fterz(k)/1000);
        elseif fterz(k)<70
            fstr{k}=sprintf('%3.1f',fterz(k));
        else
            fstr{k}=sprintf('%2.0f',fterz(k));
        end
    end
end

subplot(311)
Nfft=size(hrir_sph,1);
f=(0:Nfft-1)/Nfft*fs;
H=fft(hrir_sph);

plot(f,db(H));
set(gca,'XScale','log','Xtick',fterz,'XTickLabel',fstr);
grid on
xlim([20 20000])
ylabel('|H| in dB')
subplot(312)
plot(f,angle(H)*180/pi)
set(gca,'XScale','log','Xtick',fterz,'XTickLabel',fstr);
grid on
xlim([20 20000])
ylabel('\angle H in ')
subplot(313)
A=angle(H);
G=(mod(circshift(A,1)-A+pi,2*pi)-pi)*Nfft/(2*pi)/fs*1e6;
plot(f,G)
set(gca,'XScale','log','Xtick',fterz,'XTickLabel',fstr);
grid on
xlim([20 20000])
ylim([-.7 .7]*1000)
ylabel('gdly H in \mus')
%%


load hrir_sph;
fs=44100;
fterz=[1000 1265 1600]'*2.^(-6:5);
fterz=fterz(:);
fstr=cell(1,length(fterz));
for k=1:length(fterz)
    if mod(k,3)==1
        if fterz(k)>999
            fstr{k}=sprintf('%2.0fk',fterz(k)/1000);
        elseif fterz(k)<70
            fstr{k}=sprintf('%3.1f',fterz(k));
        else
            fstr{k}=sprintf('%2.0f',fterz(k));
        end
    end
end
figure(1)
clf
subplot(311)
Nfft=size(hrir_sph,1);
f=(0:Nfft-1)/Nfft*fs;
H=fft(hrir_sph);

H=H./fliplr(H);

% H=H(:,1:20:end);

plot(f,db(H).*repmat(1./(1+sqrt(f(:)/1000)),1,size(H,2)));
set(gca,'XScale','log','Xtick',fterz,'XTickLabel',fstr);
grid on
xlim([40 15000])
ylabel('ILD in dB')
subplot(312)
plot(f,angle(H)*180/pi)
set(gca,'XScale','log','Xtick',fterz,'XTickLabel',fstr);
grid on
xlim([40 15000])
ylabel('IPD in ')
subplot(313)
A=angle(H);
G=(mod(circshift(A,1)-A+pi,2*pi)-pi)*Nfft/(2*pi)/fs*1e6;
plot(f,G)
hold on
for k=8:size(A,1)
    A(k,:)=A(k,:)-round((A(k,:)-A(k-1,:))/(2*pi))*2*pi;
end
G=A.*repmat(1./(2*pi*f(:)),1,size(A,2));
plot(f,G*1e6)
set(gca,'XScale','log','Xtick',fterz,'XTickLabel',fstr);
grid on
xlim([40 15000])
ylim([-1.4 1.4]*1000)
ylabel('ITD or unwrIPD/w in \mus')
%%
figure(2)
clf
subplot(211)
phi=linspace(-90,90,size(H,2));
ITD=G';
idx=[13 24 48 94 188];
idx1=idx;
% ITD=ITD(:,idx);
octinterval=1;
ITD=[mean(ITD(:,2^(-octinterval)*idx(1):2^(octinterval)*idx(1)),2),...
     mean(ITD(:,2^(-octinterval)*idx(2):2^(octinterval)*idx(2)),2),...
     mean(ITD(:,2^(-octinterval)*idx(3):2^(octinterval)*idx(3)),2),...
     mean(ITD(:,2^(-octinterval)*idx(4):2^(octinterval)*idx(4)),2),...
     mean(ITD(:,2^(-octinterval)*idx(5):2^(octinterval)*idx(5)),2),...
    ];
plot(phi,ITD*1e6)
legend('125','250','500','1k','2k')
grid on
xlim([-90 90])
ylabel('ITD')
subplot(212)
ILD=db(H).*repmat(1./(1+sqrt(f(:)/1000)),1,size(H,2));
ILD=ILD';
idx=[94 188 373 745];
idx2=idx;
% ILD=ILD(:,idx);
ILD=[mean(ILD(:,2^(-octinterval)*idx(1):2^(octinterval)*idx(1)),2),...
     mean(ILD(:,2^(-octinterval)*idx(2):2^(octinterval)*idx(2)),2),...
     mean(ILD(:,2^(-octinterval)*idx(3):2^(octinterval)*idx(3)),2),...
     mean(ILD(:,2^(-octinterval)*idx(4):2^(octinterval)*idx(4)),2),...
    ];
plot(phi,ILD)
ylabel('ILD')
legend('1k','2k','4k','8k');
xlim([-90 90])
grid on
%%
ILD=[ILD;ILD(end-1:-1:2,:)]/6;
ITD=[ITD;ITD(end-1:-1:2,:)]*1.2e3;

dILD=(ILD-circshift(ILD,-1))*180/pi/8;
dITD=(ITD-circshift(ITD,-1))*180/pi;

ILD=circshift(ILD,-90);
ITD=circshift(ITD,-90);
dITD=circshift(dITD,-90);
dILD=circshift(dILD,-90);

%%
figure(3)
for k=1:3:360
    clf
    subplot(211)
    plot(ITD(1:k,:),dITD(1:k,:))
    grid on
    axis equal
    axis([-1 1 -1 1])
    legend('125','250','500','1k','2k','location','eo')
    subplot(212)
    plot(ILD(1:k,:),dILD(1:k,:))
    axis equal
    axis([-1 1 -1 1]*1.5)
    legend('1k','2k','4k','8k','location','eo');
    grid on
    pause(.05)
end
%%
maxdyn=30;
[xx,yy]=meshgrid(-180:179);
Dmean=zeros(size(xx));
for k=1:size(ILD,2)
    X=repmat(ITD(:,k),1,size(ITD,1));
    Y=repmat(dITD(:,k),1,size(dITD,1));
    D=dB((X-X').^2+.1*(Y-Y').^2)/2;
    D=max((D-max(D(:)))/maxdyn+1,0);
    Dmean=Dmean+D;
    cla
    p=pcolor(xx,yy,D);
    hold on
    plot([0 0 NaN -180 180],[-180 180 NaN 0 0],'b:')
    plot([90 90 NaN -180 180],[-180 180 NaN 90 90],'r:')
    plot([-90 -90 NaN -180 180],[-180 180 NaN -90 -90],'r:')
    set(p,'EdgeColor','none')
    axis([-95 5 -95 5])
    colormap(gray)
    title(['confusibility of Euclidian distance in (ITD,dITD/10) f=' num2str(round(f(idx1(k))))])
    set(gcf,'PaperUnits','centimeters','PaperPosition',[0 0 12 10])
    print('-dpng',['ITDdITDconfusion' num2str(round(f(idx1(k)))) '.png'])
    pause
end
%%
for k=1:size(ILD,2)
    X=repmat(ILD(:,k),1,size(ILD,1));
    Y=repmat(dILD(:,k),1,size(dILD,1));
    D=dB((X-X').^2+8/10*(Y-Y').^2)/2;
    D=max((D-max(D(:)))/maxdyn+1,0);
    Dmean=Dmean+D;
    cla
    p=pcolor(xx,yy,D);
    hold on
    plot([0 0 NaN -180 180],[-180 180 NaN 0 0],'b:')
    plot([90 90 NaN -180 180],[-180 180 NaN 90 90],'r:')
    plot([-90 -90 NaN -180 180],[-180 180 NaN -90 -90],'r:')
    set(p,'EdgeColor','none')
    axis([-95 5 -95 5])
    colormap(gray)
    title(['confusibility of Euclidian distance in (ILD,dILD/10) f=' num2str(round(f(idx2(k))))])
    set(gcf,'PaperUnits','centimeters','PaperPosition',[0 0 12 10])
    print('-dpng',['ILDdILDconfusion' num2str(round(f(idx2(k)))) '.png'])
    pause
end

%% stereo panning
load sphdiffr.mat
close all
Tgr=[Tgr,Tgr(:,end-1:-1:2)];
Tph=[Tph,Tph(:,end-1:-1:2)];
HdB=[HdB,HdB(:,end-1:-1:2)];
H=10.^(HdB/20);

% just because it looks good
% Tgr=Tph;

ITDs=(Tgr'-circshift(Tgr',180))';
dITDs=ITDs-circshift(ITDs,1);

ILDs=(HdB'-circshift(HdB',180))';
dILDs=ILDs-circshift(ILDs,1);

alpha=30;
phi0=90;

phi1L=mod((phi0-alpha)+360-1,360)+1;
phi2L=mod((phi0+alpha)+360-1,360)+1;
phi1R=mod(180-(phi0-alpha)+360-1,360)+1;
phi2R=mod(180-(phi0+alpha)+360-1,360)+1;

phi1L1=mod((phi0-alpha)+360-2,360)+1;
phi2L1=mod((phi0+alpha)+360-2,360)+1;
phi1R1=mod(180-(phi0-alpha)+360-2,360)+1;
phi2R1=mod(180-(phi0+alpha)+360-2,360)+1;

L=-21:3:21;

ITDst=zeros(length(f),length(L));
dITDst=zeros(length(f),length(L));
ILDst=zeros(length(f),length(L));
dILDst=zeros(length(f),length(L));

Phi=zeros(length(f),length(L));

for k=1:length(f)
    sigma=2/(f(k)*2^(1/6));
%    sigma=1/f(k);
%     sigma=f(k);

    [tL,aL]=time_centroid_two_gauss(...
        H(k,phi1L)*10.^(L/40),...
        H(k,phi2L)*10.^(-L/40),...
        Tgr(k,phi1L),Tgr(k,phi2L),...
        Tph(k,phi1L),Tph(k,phi2L),...
        2*pi*f(k),sigma);
    [tR,aR]=time_centroid_two_gauss(...
        H(k,phi1R)*10.^(L/40),...
        H(k,phi2R)*10.^(-L/40),...
        Tgr(k,phi1R),Tgr(k,phi2R),...
        Tph(k,phi1R),Tph(k,phi2R),...
        2*pi*f(k),sigma);
    [tL1,aL1]=time_centroid_two_gauss(...
        H(k,phi1L1)*10.^(L/40),...
        H(k,phi2L1)*10.^(-L/40),...
        Tgr(k,phi1L1),Tgr(k,phi2L1),...
        Tph(k,phi1L1),Tph(k,phi2L1),...
        2*pi*f(k),sigma);
    [tR1,aR1]=time_centroid_two_gauss(...
        H(k,phi1R1)*10.^(L/40),...
        H(k,phi2R1)*10.^(-L/40),...
        Tgr(k,phi1R1),Tgr(k,phi2R1),...
        Tph(k,phi1R1),Tph(k,phi2R1),...
        2*pi*f(k),sigma);

    ITDst(k,:)=tR-tL;
   dITDst(k,:)=(tR-tL)-(tR1-tL1);
    ILDst(k,:)=aR-aL;
   dILDst(k,:)=(aR-aL)-(aR1-aL1);
%     plot(L,ITDst(k,:)*1e3)
%     ylim([-1 1]*.7)
    hdbnrml=6*(f(k)/700).^2./(1+(f(k)/700).^2);
%     hdbnrml(:)=1;
    for l=1:length(L)
        p=1;
        d=1*abs(ITDst(k,l) -ITDs(k,:)).^p*(2*1.2e3)^p+...
        1*abs(dITDst(k,l)-dITDs(k,:)).^p*(2*1.2e3)^p+...
        1*abs(ILDst(k,l) -ILDs(k,:)).^p/hdbnrml.^p+...
        1*abs(dILDst(k,l)-dILDs(k,:)).^p/hdbnrml.^p;
        [~,Phi(k,l)]=min(d);
    end
%     plot(L,Phi(k,:)-90)
%     ylim([-40 40])
%     xlim([min(L) max(L)])
%     grid on
%     title(['f=' num2str(f(k))])
%     pause(.1)
end

fterz=[1000 1265 1600]'*2.^(-6:4);
fterz=fterz(:);
fstr=cell(1,length(fterz));
for k=1:length(fterz)
    if mod(k,3)==1
        if fterz(k)>999
            fstr{k}=sprintf('%2.0fk',fterz(k)/1000);
        elseif fterz(k)<70
            fstr{k}=sprintf('%3.1f',fterz(k));
        else
            fstr{k}=sprintf('%2.0f',fterz(k));
        end
    end
end

plot(f,Phi-91),
set(gca','XScale','log','XTick',fterz,'XTickLabel',fstr,...
    'YTick',-35:5:35)
xlim([50 16000]);
ylim([-1 1]*37);
grid on
%%
close all
figure,
subplot(211),
plot(f,2*1.2e3*ITDs(:,1+[90-30:10:90+30])),
set(gca,'XScale','log'),
xlim([50 16000])
ylim([-1 1]*2)
grid on,
subplot(212),
plot(f,2*1.2e3*ITDst(:,1:4:end)),
set(gca,'XScale','log'),
xlim([50 16000])
ylim([-1 1]*2)
grid on;
% 
% figure
% subplot(211)
% plot(f,2*180/pi*1.2e3*dITDs(:,1+[90-30:10:90+30])),
% set(gca,'XScale','log'),
% xlim([50 16000])
% ylim([-1 1]*.7)
% grid on,
% subplot(212),
% plot(f,2*180/pi*1.2e3*dITDst(:,1:4:end)),
% set(gca,'XScale','log'),
% xlim([50 16000])
% ylim([-1 1]*.7)
% grid on;
% 

hdbnrml=6*(f/700).^2./(1+(f/700).^2);
figure,
subplot(211),
plot(f,diag(1./hdbnrml)*ILDs(:,1+(90-30:10:90+30))),
set(gca,'XScale','log'),
xlim([50 16000])
ylim([-1 1]*2)
grid on,
subplot(212),
plot(f,diag(1./hdbnrml)*ILDst(:,1:4:end)),
set(gca,'XScale','log'),
xlim([50 16000])
ylim([-1 1]*2)
grid on;





