function ynd=sph_neumann_diff(x,N)
% function ynd=sph_neumann_diff(x,N)
%
% evaluates all derivatives of the 
% spherical Neumann functions 
% (part of the singular solution)
% up to the degree N
% the definition was taken from:
%
% E. G. Williams, "Fourier Acoustics", 
% Academic Press, San Diego, 1999.
%
% this function depends on 
% sph_neumann.m
%
% Franz Zotter (zotter@iem.at), 
% Institute of Electronic Music and Acoustics,
% 2007.
%
x=x(:);

ofs=1;
yn=sph_neumann(x,N+1);
ynd=zeros(length(x),N+1);

for n=0:N
   ynd(:,n+ofs)=n./x.*yn(:,n+ofs)-yn(:,n+1+ofs);
end
       

