y=wavread('psypan.wav');
y=reshape(y(1:5*1024,:),[1024,5,2]);

subplot(211)
t=(0:1023)*44.1;
plot(y(130:180,:,1),'linewidth',2)
xlabel('t in ms')
ylabel('h(t)')
legend('0','1/4','1/2','3/4','1','location','nw');
axis tight
grid on

subplot(212)
y=db(fft(y));
y=y(1:513,:,1);
f=linspace(0,22050,513);
plot(f,y,'linewidth',2);
ylabel('|psypan|')
xlabel('frequency in Hz')
legend('0','1/4','1/2','3/4','1','location','sw');
grid on
xlim([32 22000])
ylim([-3 3])
set(gca,'XScale','log','XTick',...
    [25 32 40 50 63 80 100 125 160 200 ...
    250 316 400 500 625 800 1000 1250 1600 2000 ...
    2500 3150 4000 5000 6300 8000 10000 12500 16000 20000],...
    'XTickLabel',...
    {'0','32','','','63','','','125','','','250','','','500','',...
    '','1k','','','2k','','','4k','','','8k','','','16k',''},...
    'XMinorTick','off')

set(gcf,'PaperUnits','centimeters','PaperPosition',[0 0 13 8])
print('-dpng','-r300','psypan.png')

